Index: trunk/source/geometry/solids/specific/src/G4TwistedTrd.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistedTrd.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistedTrd.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTrd.cc,v 1.7 2006/06/29 18:49:25 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4TwistedTubs.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4TwistedTubs.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4TwistedTubs.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TwistedTubs.cc,v 1.24 2007/05/18 07:39:56 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4VCSGfaceted.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4VCSGfaceted.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4VCSGfaceted.cc	(revision 1228)
@@ -30,6 +30,6 @@
 // and all its terms.
 //
-// $Id: G4VCSGfaceted.cc,v 1.25 2008/05/22 10:22:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4VCSGfaceted.cc,v 1.26 2009/05/08 14:29:56 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -550,5 +550,5 @@
 {
   if(fSurfaceArea != 0.) {;}
-  else   { fSurfaceArea = EstimateCubicVolume(fStatistics,fAreaAccuracy); }
+  else   { fSurfaceArea = EstimateSurfaceArea(fStatistics,fAreaAccuracy); }
   return fSurfaceArea;
 }
Index: trunk/source/geometry/solids/specific/src/G4VFacet.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4VFacet.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4VFacet.cc	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4VFacet.cc,v 1.8 2008/12/18 12:57:38 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Index: trunk/source/geometry/solids/specific/src/G4VTwistSurface.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4VTwistSurface.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4VTwistSurface.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VTwistSurface.cc,v 1.9 2007/05/31 13:52:48 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/specific/src/G4VTwistedFaceted.cc
===================================================================
--- trunk/source/geometry/solids/specific/src/G4VTwistedFaceted.cc	(revision 1227)
+++ trunk/source/geometry/solids/specific/src/G4VTwistedFaceted.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4VTwistedFaceted.cc,v 1.18 2007/05/25 09:42:34 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/History
===================================================================
--- trunk/source/geometry/volumes/History	(revision 1227)
+++ trunk/source/geometry/volumes/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.155 2008/11/13 09:35:03 gcosmo Exp $
+$Id: History,v 1.163 2009/11/06 11:35:03 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,27 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+Nov 6th, 2009       G.Cosmo - geomvol-V09-02-04
+- Moved inline constructors to source for G4TouchableHistory, to avoid problems
+  of memory alignment in allocation.
+
+Nov 3rd, 2009       G.Cosmo - geomvol-V09-02-03
+- Use G4Allocator for dynamic allocation of G4TouchableHistory objects.
+  Should reduce the number of direct calls to malloc and memory fragmentation.
+  Measured an average improvement of 3-5% in CPU speed, and same memory
+  footprint.
+
+Sep 22nd, 2009      G.Cosmo - geomvol-V09-02-02
+- Added missing implementation for composing G4AssemblyVolume constructor.
+
+Sep 21st, 2009      G.Cosmo - geomvol-V09-02-01
+- Fix in G4PVParameterised::CheckOverlaps() to not modify daughter volume
+  transformation matrix for application to points in the daughter's frame.
+  Adopt Inverse() instead of Invert() in call to G4AffineTransform.
+  Addresses problem report #1078.
+
+Aug 3rd, 2009       G.Cosmo - geomvol-V09-02-00
+- Get rid of unnecessary call to Reset() in G4NavigationHistory destructor.
+- Some code formatting...
 
 Nov 13th, 2008      G.Cosmo - geomvol-V09-01-03
Index: trunk/source/geometry/volumes/include/G4AssemblyTriplet.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4AssemblyTriplet.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4AssemblyTriplet.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AssemblyTriplet.hh,v 1.3 2007/11/16 16:20:25 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4AssemblyTriplet.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4AssemblyTriplet.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4AssemblyTriplet.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AssemblyTriplet.icc,v 1.2 2006/06/29 18:56:49 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4AssemblyVolume.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4AssemblyVolume.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4AssemblyVolume.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AssemblyVolume.hh,v 1.7 2006/06/29 18:56:51 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4AssemblyVolume.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4AssemblyVolume.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4AssemblyVolume.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AssemblyVolume.icc,v 1.3 2006/06/29 18:56:53 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4GRSSolid.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSSolid.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSSolid.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSSolid.hh,v 1.8 2006/06/29 18:56:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4GRSSolid.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSSolid.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSSolid.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSSolid.icc,v 1.9 2006/06/29 18:56:57 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4GRSSolidHandle.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSSolidHandle.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSSolidHandle.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSSolidHandle.hh,v 1.6 2006/06/29 18:56:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Class G4GRSSolidHandle
Index: trunk/source/geometry/volumes/include/G4GRSVolume.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSVolume.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSVolume.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSVolume.hh,v 1.8 2006/06/29 18:57:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4GRSVolume.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSVolume.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSVolume.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSVolume.icc,v 1.10 2006/06/29 18:57:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4GRSVolumeHandle.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4GRSVolumeHandle.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4GRSVolumeHandle.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSVolumeHandle.hh,v 1.6 2006/06/29 18:57:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Class G4GRSVolumeHandle
Index: trunk/source/geometry/volumes/include/G4LogicalBorderSurface.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4LogicalBorderSurface.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4LogicalBorderSurface.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalBorderSurface.hh,v 1.17 2008/08/19 15:31:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4LogicalBorderSurface
Index: trunk/source/geometry/volumes/include/G4LogicalBorderSurface.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4LogicalBorderSurface.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4LogicalBorderSurface.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalBorderSurface.icc,v 1.9 2006/06/29 18:57:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4LogicalSkinSurface.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4LogicalSkinSurface.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4LogicalSkinSurface.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalSkinSurface.hh,v 1.17 2008/08/19 15:31:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4LogicalSkinSurface
Index: trunk/source/geometry/volumes/include/G4LogicalSkinSurface.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4LogicalSkinSurface.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4LogicalSkinSurface.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalSkinSurface.icc,v 1.9 2006/06/29 18:57:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4NavigationHistory.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationHistory.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationHistory.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationHistory.hh,v 1.13 2006/06/29 18:57:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationHistory.hh,v 1.14 2009/11/03 09:15:51 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4NavigationHistory
@@ -47,4 +47,5 @@
 #include "geomdefs.hh"
 
+//#include "G4Allocator.hh"
 #include "G4AffineTransform.hh"
 #include "G4VPhysicalVolume.hh"
@@ -141,5 +142,6 @@
  private:
 
-  std::vector<G4NavigationLevel>  fNavHistory;
+  std::vector<G4NavigationLevel> fNavHistory;
+  //std::vector<G4NavigationLevel, G4Allocator<G4NavigationLevel> > fNavHistory;
 
   G4int fStackDepth;
Index: trunk/source/geometry/volumes/include/G4NavigationHistory.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationHistory.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationHistory.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationHistory.icc,v 1.12 2006/06/29 18:57:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationHistory.icc,v 1.14 2009/08/04 08:27:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -37,5 +37,5 @@
 G4NavigationHistory::operator=(const G4NavigationHistory &h)
 {
-  if (&h == this) return *this;
+  if (&h == this)  { return *this; }
 
   // fNavHistory=h.fNavHistory;   // This works, but is very slow.
Index: trunk/source/geometry/volumes/include/G4NavigationLevel.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationLevel.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationLevel.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationLevel.hh,v 1.16 2006/06/29 18:57:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationLevel.hh,v 1.18 2009/08/04 08:27:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4NavigationLevel
Index: trunk/source/geometry/volumes/include/G4NavigationLevel.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationLevel.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationLevel.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationLevel.icc,v 1.20 2006/06/29 18:57:25 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationLevel.icc,v 1.22 2009/08/04 08:27:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 30.09.97 J.Apostolakis Initial version. 
Index: trunk/source/geometry/volumes/include/G4NavigationLevelRep.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationLevelRep.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationLevelRep.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NavigationLevelRep.hh,v 1.9 2006/06/29 18:57:27 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4NavigationLevelRep
Index: trunk/source/geometry/volumes/include/G4NavigationLevelRep.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4NavigationLevelRep.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4NavigationLevelRep.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NavigationLevelRep.icc,v 1.14 2006/06/29 18:57:29 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //  1 October 1997 J.Apostolakis Initial version. 
Index: trunk/source/geometry/volumes/include/G4PVParameterised.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4PVParameterised.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4PVParameterised.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PVParameterised.hh,v 1.8 2007/04/11 07:56:38 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4PVPlacement.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4PVPlacement.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4PVPlacement.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PVPlacement.hh,v 1.8 2007/04/11 07:56:38 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4PVReplica.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4PVReplica.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4PVReplica.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PVReplica.hh,v 1.5 2006/06/29 18:57:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4ReflectionFactory.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4ReflectionFactory.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4ReflectionFactory.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ReflectionFactory.hh,v 1.4 2008/11/13 09:33:20 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/include/G4TouchableHistory.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4TouchableHistory.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4TouchableHistory.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TouchableHistory.hh,v 1.8 2006/06/29 18:57:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4TouchableHistory.hh,v 1.11 2009/11/06 11:10:35 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -34,5 +34,5 @@
 //
 // Object representing a touchable detector element, and its history in the
-// geomtrical hierarchy, including its net resultant local->global transform.
+// geometrical hierarchy, including its net resultant local->global transform.
 
 // History:
@@ -45,4 +45,5 @@
 
 #include "G4NavigationHistory.hh"
+#include "G4Allocator.hh"
 #include "G4LogicalVolume.hh"
 #include "G4ThreeVector.hh"
@@ -60,5 +61,5 @@
     // It is for initialisation only.  
 
-  virtual ~G4TouchableHistory();
+ ~G4TouchableHistory();
 
   inline G4VPhysicalVolume* GetVolume( G4int depth=0 ) const;
@@ -72,6 +73,6 @@
     // Access methods for touchables with history
 
-  virtual void  UpdateYourself( G4VPhysicalVolume*   pPhysVol,
-                          const G4NavigationHistory* history=0 ); 
+  void  UpdateYourself( G4VPhysicalVolume*   pPhysVol,
+                        const G4NavigationHistory* history=0 ); 
     // Update methods for touchables with history
 
@@ -81,4 +82,8 @@
     // Should this method be "deprecated" ?
     // it is used now in G4Navigator::LocateGlobalPointAndSetup
+
+  inline void *operator new(size_t);
+  inline void operator delete(void *aTH);
+    // Override "new" and "delete" to use "G4Allocator".
 
  private:
Index: trunk/source/geometry/volumes/include/G4TouchableHistory.icc
===================================================================
--- trunk/source/geometry/volumes/include/G4TouchableHistory.icc	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4TouchableHistory.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TouchableHistory.icc,v 1.10 2006/12/07 14:26:28 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4TouchableHistory.icc,v 1.13 2009/11/06 11:10:35 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -32,22 +32,9 @@
 // ----------------------------------------------------------------------
 
-inline
-G4TouchableHistory::G4TouchableHistory()
-  : frot(G4RotationMatrix()),
-    ftlate(G4ThreeVector(0.,0.,0.)),
-    fhistory()
-{
-   G4VPhysicalVolume* pPhysVol=0;
-   fhistory.SetFirstEntry(pPhysVol);
-}
-
-inline
-G4TouchableHistory::G4TouchableHistory( const G4NavigationHistory &history )
-  : fhistory(history)
-{
-  G4AffineTransform tf(fhistory.GetTopTransform().Inverse());
-  ftlate = tf.NetTranslation();
-  frot = tf.NetRotation();
-}
+#if defined G4GEOM_ALLOC_EXPORT
+  extern G4DLLEXPORT G4Allocator<G4TouchableHistory> aTouchableHistoryAllocator;
+#else
+  extern G4DLLIMPORT G4Allocator<G4TouchableHistory> aTouchableHistoryAllocator;
+#endif
 
 inline
@@ -103,6 +90,5 @@
 G4int G4TouchableHistory::MoveUpHistory( G4int num_levels )
 {
-  G4NavigationHistory* nHistory= &fhistory;
-  G4int maxLevelsMove = nHistory->GetDepth();
+  G4int maxLevelsMove = fhistory.GetDepth();
   G4int minLevelsMove = 0;              // Cannot redescend today!
                                         // Soon it will be possible
@@ -117,5 +103,5 @@
     num_levels = minLevelsMove;
   }
-  nHistory->BackLevel( num_levels ); 
+  fhistory.BackLevel( num_levels ); 
 
   return num_levels;
@@ -127,2 +113,18 @@
   return &fhistory;
 }
+
+// There is no provision in case this class is subclassed.
+// If it is subclassed, this will fail and may not give errors!
+//
+inline
+void* G4TouchableHistory::operator new(size_t)
+{
+  return (void *) aTouchableHistoryAllocator.MallocSingle();
+}
+
+inline
+void G4TouchableHistory::operator delete(void *aTH)
+{
+  aTouchableHistoryAllocator.FreeSingle((G4TouchableHistory *) aTH);
+}
+
Index: trunk/source/geometry/volumes/include/G4TouchableHistoryHandle.hh
===================================================================
--- trunk/source/geometry/volumes/include/G4TouchableHistoryHandle.hh	(revision 1227)
+++ trunk/source/geometry/volumes/include/G4TouchableHistoryHandle.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TouchableHistoryHandle.hh,v 1.6 2006/06/29 18:57:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Class G4TouchableHistoryHandle
Index: trunk/source/geometry/volumes/src/G4AssemblyVolume.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4AssemblyVolume.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4AssemblyVolume.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4AssemblyVolume.cc,v 1.11 2008/02/03 09:12:50 ivana Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4AssemblyVolume.cc,v 1.12 2009/09/22 13:58:48 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -48,9 +48,22 @@
 //
 G4AssemblyVolume::G4AssemblyVolume()
-: fAssemblyID( 0 )
+  : fAssemblyID( 0 )
 {
   InstanceCountPlus();
   SetAssemblyID( GetInstanceCount() );
   SetImprintsCount( 0 );
+}
+
+// Composing constructor
+//
+G4AssemblyVolume::G4AssemblyVolume( G4LogicalVolume* volume,
+                                    G4ThreeVector& translation,
+                                    G4RotationMatrix* rotation )
+  : fAssemblyID( 0 )
+{
+  InstanceCountPlus();
+  SetAssemblyID( GetInstanceCount() );
+  SetImprintsCount( 0 );
+  AddPlacedVolume(volume, translation, rotation);
 }
 
Index: trunk/source/geometry/volumes/src/G4GRSSolid.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4GRSSolid.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4GRSSolid.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSSolid.cc,v 1.8 2006/06/29 18:57:53 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/src/G4GRSVolume.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4GRSVolume.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4GRSVolume.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GRSVolume.cc,v 1.8 2006/06/29 18:57:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/src/G4LogicalBorderSurface.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4LogicalBorderSurface.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4LogicalBorderSurface.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalBorderSurface.cc,v 1.17 2008/08/19 15:31:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/volumes/src/G4LogicalSkinSurface.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4LogicalSkinSurface.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4LogicalSkinSurface.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalSkinSurface.cc,v 1.16 2008/08/19 15:31:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/volumes/src/G4NavigationHistory.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4NavigationHistory.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4NavigationHistory.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationHistory.cc,v 1.10 2006/06/29 18:58:02 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationHistory.cc,v 1.11 2009/08/03 16:27:37 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -51,5 +51,4 @@
 G4NavigationHistory::~G4NavigationHistory()
 {
-  Reset();  // To delete all but one current entries!
 }
 
Index: trunk/source/geometry/volumes/src/G4NavigationLevel.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4NavigationLevel.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4NavigationLevel.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NavigationLevel.cc,v 1.4 2006/06/29 18:58:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4NavigationLevel.cc,v 1.5 2009/08/03 16:13:19 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 30.09.97 J.Apostolakis Initial version. 
@@ -70,6 +70,5 @@
 G4NavigationLevel::~G4NavigationLevel()
 {
-  if( fLevelRep->RemoveAReference() )
-    delete fLevelRep; 
+  if( fLevelRep->RemoveAReference() )  { delete fLevelRep; }
 }
 
@@ -79,6 +78,5 @@
   {
     right.fLevelRep->AddAReference(); 
-    if( fLevelRep->RemoveAReference() )
-      delete fLevelRep; 
+    if( fLevelRep->RemoveAReference() )  { delete fLevelRep; }
     fLevelRep = right.fLevelRep;
   }
Index: trunk/source/geometry/volumes/src/G4NavigationLevelRep.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4NavigationLevelRep.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4NavigationLevelRep.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NavigationLevelRep.cc,v 1.2 2006/06/29 18:58:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //  1 October 1997 J.Apostolakis Initial version. 
Index: trunk/source/geometry/volumes/src/G4PVParameterised.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4PVParameterised.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4PVParameterised.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4PVParameterised.cc,v 1.10 2007/04/11 07:56:38 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4PVParameterised.cc,v 1.11 2009/09/21 10:27:05 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -226,5 +226,5 @@
         // Transform each point according to daughter's frame
         //
-        G4ThreeVector md = Td.Invert().TransformPoint(*pos);
+        G4ThreeVector md = Td.Inverse().TransformPoint(*pos);
 
         if (solidB->Inside(md)==kInside)
Index: trunk/source/geometry/volumes/src/G4PVPlacement.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4PVPlacement.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4PVPlacement.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PVPlacement.cc,v 1.16 2007/04/11 07:56:38 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/src/G4PVReplica.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4PVReplica.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4PVReplica.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PVReplica.cc,v 1.7 2006/06/29 18:58:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/src/G4ReflectionFactory.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4ReflectionFactory.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4ReflectionFactory.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ReflectionFactory.cc,v 1.9 2008/11/13 09:33:20 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/volumes/src/G4TouchableHistory.cc
===================================================================
--- trunk/source/geometry/volumes/src/G4TouchableHistory.cc	(revision 1227)
+++ trunk/source/geometry/volumes/src/G4TouchableHistory.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4TouchableHistory.cc,v 1.12 2006/06/29 18:58:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4TouchableHistory.cc,v 1.15 2009/11/06 11:10:35 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -34,4 +34,23 @@
 
 #include "G4TouchableHistory.hh"
+
+G4Allocator<G4TouchableHistory> aTouchableHistoryAllocator;
+
+G4TouchableHistory::G4TouchableHistory()
+  : frot(G4RotationMatrix()),
+    ftlate(G4ThreeVector(0.,0.,0.)),
+    fhistory()
+{
+   G4VPhysicalVolume* pPhysVol=0;
+   fhistory.SetFirstEntry(pPhysVol);
+}
+
+G4TouchableHistory::G4TouchableHistory( const G4NavigationHistory &history )
+  : fhistory(history)
+{
+  G4AffineTransform tf(fhistory.GetTopTransform().Inverse());
+  ftlate = tf.NetTranslation();
+  frot = tf.NetRotation();
+}
 
 G4TouchableHistory::~G4TouchableHistory()
Index: trunk/source/global/HEPGeometry/include/G4LorentzRotation.hh
===================================================================
--- trunk/source/global/HEPGeometry/include/G4LorentzRotation.hh	(revision 1227)
+++ trunk/source/global/HEPGeometry/include/G4LorentzRotation.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LorentzRotation.hh,v 1.5 2006/06/29 18:59:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 #ifndef G4LorentzRotation_hh
Index: trunk/source/global/HEPGeometry/include/G4LorentzVector.hh
===================================================================
--- trunk/source/global/HEPGeometry/include/G4LorentzVector.hh	(revision 1227)
+++ trunk/source/global/HEPGeometry/include/G4LorentzVector.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LorentzVector.hh,v 1.5 2006/06/29 18:59:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 #ifndef G4LorentzVector_hh
